/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_isin.c,v 1.2 1997/09/25 18:18:26 ae59 Exp $ */
/*
$Log: t_isin.c,v $
 * Revision 1.2  1997/09/25  18:18:26  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:36  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_isin.c                              */
/*                                                              */
/*      Date            : 1992-01-16                            */
/*      1992-01-16 : both values between -1,1 in special case   */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctInterval replaced         */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-09-06 : reduce maximum line length                 */
/*      1991-08-05 : remove unused variables jdiff              */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctInterval(t_isin,isinee) */
#ifdef LINT_ARGS
a_intv t_isin(a_intv ai)
#else
a_intv t_isin(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_isin")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = isinee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_isin")
        return res;
        }

/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | isin                                                         |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int isinee(const IExtReal *arg, IExtReal *res)
#else
int isinee(arg, res)
const IExtReal *arg;
      IExtReal *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int isinee(IExtReal *arg, IExtReal *res)
#else
int isinee(arg, res)
IExtReal *arg;
IExtReal *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   IDReal      v;          /* Produkt des Arguments mit 2/pi    */
   IExtReal    j;          /* Ganzzahliger Anteil von v         */
   int         jmod4u;     /* j.u modulo 4                      */
   int         jmod4l;     /* j.l modulo 4                      */
   int         ret;        /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument, dann Pruefung aus --- */
   ArgCheckI1(ISin, arg, res);
   arg_check = Off;

   /* --- ganzzahliger Anteil von arg --- */
   gza_trg(&(arg->u), J_Init_Sin, Period_PiHalf, &v.u, &j.u, &jmod4u);
   gza_trg(&(arg->l), J_Init_Sin, Period_PiHalf, &v.l, &j.l, &jmod4l);

   /* --- Reduktion und Sinus --- */
   if(( ret = isincos(&v, &j, jmod4u, jmod4l, res)) & Except)
      if((ret&Except)!=PLOSS){
         return ret & Except;
      }

   /* --- Rundungs-Fehler --- */
   if(!(ret&UB_Exact)) round_rel(UP,   &(res->u), &EpsSin, &(res->u));
   if(!(ret&LB_Exact)) round_rel(DOWN, &(res->l), &EpsSin, &(res->l));

   /* Ergebnisverbesserung in Spezialfaellen */
#if INT_HPREC
   { int vz;
     if (1==cmpee(&(res->u), &One))             /* sin x > 1 */
        copyee(&One, &(res->u));
     if (-1==cmpee(&(res->l), &MinusOne))       /* sin x < -1 */
        copyee(&MinusOne, &(res->l));
     if (-1==cmpee(&(arg->u), &One) &&
         1==cmpee(&(arg->l), &MinusOne))
        {
        vz = SGNE(&(arg->u));
        if (vz==POS&&-1==cmpee(&(arg->u), &(res->u)))  /* x > sin x */
           copyee(&(arg->u), &(res->u));
        vz = SGNE(&(arg->l));
        if (vz==NEG&&1==cmpee(&(arg->l), &(res->l)))   /* x < sin x */
           copyee(&(arg->l), &(res->l));
        }
   }
#endif /* INT_HPREC */

   /* --- ArgPruefung wieder an --- */
   arg_check = On;

   /* --- kein Fehler mehr moeglich --- */
   return NoErr;
} /* isin() */


